#version 430 core
/*
* Copyright 2018 Vienna University of Technology.
* Institute of Computer Graphics and Algorithms.
* This file is part of the ECG Lab Framework and must not be redistributed.
*/

in VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
} vert;

out vec4 color;

uniform sampler2D diffuseTexture;

uniform float ambientStrength;

uniform struct DirectionalLight {
	vec3 color;
	vec3 direction;
} dirL;

void main() {	
	vec3 n = normalize(vert.normal_world);
	float finalIntensity = max(0.0, dot(n, -dirL.direction));
	if(finalIntensity > 0.95) {
		finalIntensity = 1.0;
	}
	else if(finalIntensity > 0.5) {
		finalIntensity = 0.7;
	}
	else if(finalIntensity > 0.1) {
		finalIntensity = 0.35;
	}
	else finalIntensity = 0.1;
		
	vec3 texColor = texture(diffuseTexture, vert.uv).rgb;
	color = vec4(texColor*finalIntensity, 1.0);
}

