#version 430

in VertexData {
	vec3 position_world;
	vec3 normal_world;
} vert;


out vec4 color;

uniform struct PointLight {
	vec3 color;
	vec3 position;
	vec3 attenuation;
} pointL;

uniform vec3 objectcolor;
uniform float ambientStrength;


void main(){
	
    vec3 ambient = pointL.color*ambientStrength;
	    
	vec3 norm = normalize(vert.normal_world);
	vec3 lightDir = normalize(pointL.position - vert.position_world);

	float diff = max(dot(norm, lightDir), 0.0);
	vec3 diffuse = diff * pointL.color;
	
	
   

    vec3 result = (ambient+diffuse)* objectcolor;
    color = vec4(result, 1.0f);

}