#version 430 core

layout(location = 0) in vec3 inPosition;
layout(location = 1) in vec2 inTexCoord;

uniform mat4 projMatrix;
uniform mat4 viewMatrix;

smooth out vec2 vTexCoord;

uniform float waveHeight;
uniform float timePassed;

uniform vec3 offset;

void main() {
	mat4 viewProjMatrix = projMatrix*viewMatrix;
	vTexCoord = inTexCoord;
	
	vec3 vFinalPosition = (inPosition+offset);
	
	vFinalPosition.y += sin(vFinalPosition.x + timePassed)*waveHeight;
	
	gl_Position = viewProjMatrix * vec4(vFinalPosition, 1.0);
}